﻿using Android.App;
using Android.Widget;
using Android.OS;
using Com.Syncfusion.Charts;
using System.Collections.ObjectModel;
using Android.Graphics;
using Android.Views;
using System;

namespace ZoomPanSample
{
    [Activity(Label = "ZoomPanSample", MainLauncher = true, Icon = "@drawable/icon")]
    public class MainActivity : Activity
    {
        ChartZoomPanBehavior zoomPan;
        DateTimeAxis xAxis;
        NumericalAxis yAxis;
        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);

            LinearLayout rootLayout = new LinearLayout(this);
            rootLayout.Orientation = Orientation.Vertical;

            SfChart chart = new SfChart(this);
            chart.LayoutParameters = new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MatchParent, ViewGroup.LayoutParams.MatchParent);
            chart.SetBackgroundColor(Color.White);

            xAxis = new DateTimeAxis();
            chart.PrimaryAxis = xAxis;

            yAxis = new NumericalAxis();
            chart.SecondaryAxis = yAxis;

            LineSeries series = new LineSeries();
            series.ItemsSource = GetData();
            series.XBindingPath = "XValue";
            series.YBindingPath = "YValue";
            chart.Series.Add(series);

            zoomPan = new ChartZoomPanBehavior();
            chart.Behaviors.Add(zoomPan);

            Button button = new Button(this);
            button.Text = "Zoom";
            button.Click += Button_Click;

            rootLayout.AddView(button);
            rootLayout.AddView(chart);
            // Set our view from the "main" layout resource
            SetContentView(rootLayout);
        }

        private void Button_Click(object sender, System.EventArgs e)
        {
            double startDate = new DateTime(2017, 10, 5).ToOADate();
            double endDate = new DateTime(2017, 10, 7).ToOADate();
            zoomPan.ZoomByRange(xAxis, startDate, endDate); // Specify the range to zoom 

        }

        public static ObservableCollection<DataModel> GetData()
        {
            var dateTime = DateTime.Now;
            var datas = new ObservableCollection<DataModel>();
            datas.Add(new DataModel(dateTime.ToOADate(), 10d));
            dateTime = dateTime.AddDays(1);
            datas.Add(new DataModel(dateTime.ToOADate(), 30d));
            dateTime = dateTime.AddDays(1);
            datas.Add(new DataModel(dateTime.ToOADate(), 15d));
            dateTime = dateTime.AddDays(1);
            datas.Add(new DataModel(dateTime.ToOADate(), 65d));
            dateTime = dateTime.AddDays(1);
            datas.Add(new DataModel(dateTime.ToOADate(), 90d));
            dateTime = dateTime.AddDays(1);
            datas.Add(new DataModel(dateTime.ToOADate(), 85d));
            return datas;
        }
    }
}

